<?php

defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
define( 'NITROPACK_ADVANCED_CACHE', true);
define( 'NITROPACK_LOGGED_IN_COOKIE', /*LOGIN_COOKIES*/ );

require_once '/*NITROPACK_FUNCTIONS_FILE*/';

header('Cache-Control: no-cache');
$isManageWpRequest = !empty($_GET["mwprid"]);
if ( file_exists(NITROPACK_CONFIG_FILE) && !empty($_SERVER["HTTP_HOST"]) && !empty($_SERVER["REQUEST_URI"]) && !$isManageWpRequest ) {
    try {
        $siteConfig = nitropack_get_site_config();
        if ( $siteConfig && null !== $nitro = get_nitropack_sdk($siteConfig["siteId"], $siteConfig["siteSecret"]) ) {
            if (is_valid_nitropack_webhook()) {
                add_action('muplugins_loaded', 'nitropack_handle_webhook');
            } else {
                if (is_valid_nitropack_beacon()) {
                    add_action('muplugins_loaded', 'nitropack_handle_beacon');
                } else {
                    $GLOBALS["NitroPack.instance"] = $nitro;
                    if (nitropack_passes_cookie_requirements()) {
                        if (!empty($siteConfig["compression"])) {
                            $nitro->enableCompression();
                        }

                        if ($nitro->hasLocalCache()) {
                            header('X-Nitro-Cache: HIT');
                            setcookie("nitroCache", "HIT", time() + 10);
                            $nitro->pageCache->readfile();
                            exit;
                        } else {
                            $nitro->pageCache->useInvalidated(true);
                            if ($nitro->hasLocalCache()) {
                                header('X-Nitro-Cache: STALE');
                                $nitro->pageCache->readfile();
                                exit;
                            } else {
                                $nitro->pageCache->useInvalidated(false);
                            }
                        }
                    }
                }
            }
        }
    } catch (\Exception $e) {
        // Do nothing, cache serving will be handled by nitropack_init
    }
}
